<!DOCTYPE html>
<html>
<head>
  <title>IoT Dashboard</title>
  <style>
    body {
      display: flex;
      flex-direction: column;
      align-items: center;
      font-family: Arial, sans-serif;
    }

    h1, h2 {
      margin-bottom: 10px;
    }

    #widgetsContainer {
      display: flex;
      flex-wrap: wrap;
      justify-content: center;
      margin-bottom: 20px;
    }

    .widget {
      width: 200px;
      height: 200px;
      border: 1px solid #ccc;
      margin: 10px;
      padding: 10px;
      background-color: #f0f0f0;
      cursor: move;
    }

    .droppable {
      border: 2px dashed #aaa;
    }

    #endpointForm {
      display: flex;
      align-items: center;
    }

    #endpointInput {
      margin-right: 10px;
    }
  </style>
</head>
<body>
  <h1>IoT Dashboard</h1>

  <div id="widgetsContainer">
    <div class="widget">Widget 1</div>
    <div class="widget">Widget 2</div>
  </div>

  <h2>Add Endpoint</h2>
  <form id="endpointForm">
    <label for="endpointInput">Endpoint URL:</label>
    <input type="text" id="endpointInput" required>
    <button type="submit">Add Endpoint</button>
  </form>

  <script>
    // Function to handle widget drag and drop
    function handleDragStart(event) {
      event.dataTransfer.setData("text/plain", event.target.id);
    }

    function handleDragOver(event) {
      event.preventDefault();
    }

    function handleDrop(event) {
      event.preventDefault();
      const widgetId = event.dataTransfer.getData("text/plain");
      const widget = document.getElementById(widgetId);
      const endpointUrl = event.dataTransfer.getData("text/endpointUrl");

      // Append the endpoint URL to the widget
      const endpointElement = document.createElement("div");
      endpointElement.textContent = endpointUrl;
      widget.appendChild(endpointElement);

      // Remove the "droppable" class from the widget
      widget.classList.remove("droppable");
    }

    // Function to handle adding an endpoint
    function handleAddEndpoint(event) {
      event.preventDefault();
      const endpointUrl = document.getElementById("endpointInput").value;

      // Create a new widget element
      const widget = document.createElement("div");
      widget.classList.add("widget", "droppable");
      widget.textContent = "New Widget";

      // Set up drag and drop event listeners
      widget.addEventListener("dragstart", handleDragStart);
      widget.addEventListener("dragover", handleDragOver);
      widget.addEventListener("drop", handleDrop);

      // Append the new widget to the widgets container
      const widgetsContainer = document.getElementById("widgetsContainer");
      widgetsContainer.appendChild(widget);

      // Reset the input field
      document.getElementById("endpointInput").value = "";
    }

    // Add event listener to the endpoint form
    const endpointForm = document.getElementById("endpointForm");
    endpointForm.addEventListener("submit", handleAddEndpoint);
  </script>
</body>
</html>
